// Copyright 2017-2022 @polkadot/keyring authors & contributors
// SPDX-License-Identifier: Apache-2.0

import type { RegistryEntry } from 'https://esm.sh/@substrate/ss58-registry@1.29.1';

export type Icon = 'beachball' | 'empty' | 'jdenticon' | 'polkadot' | 'substrate';

export type KnownIcon = Record<string, Icon>;

export type KnownLedger = Record<string, number>;

export type KnownGenesis = Record<string, string[]>;

export type KnownSubstrate = RegistryEntry;

export type KnownTestnet = Record<string, true>;

export interface SubstrateNetwork extends KnownSubstrate {
  genesisHash: string[];
  hasLedgerSupport: boolean;
  icon: Icon;
  isIgnored: boolean;
  isTestnet: boolean;
  slip44?: number | null;
}

export interface Network extends SubstrateNetwork {
  network: string;
}

export interface Ss58Registry {
  registry: KnownSubstrate[];
  specification: string;
  schema: Record<keyof KnownSubstrate, string>;
}
